#version 150

#moj_import <fog.glsl>
#moj_import <color.glsl>

uniform vec4 ColorModulator;
uniform float GameTime;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;
uniform mat4 ModelViewMat;
uniform mat4 ProjMat;
uniform vec2 ScreenSize;

in float vertexDistance;

out vec4 fragColor;

float block_0(float x, float size){
    float pixel = ScreenSize.x / size;
    float _x = mod(x * ScreenSize.x, pixel * 20);
    if(_x < pixel) return (-1.0 * pixel) / ScreenSize.y;
    else if(_x < 4 * pixel) return (0.0 * pixel) / ScreenSize.y;
    else if(_x < 6 * pixel) return (1.0 * pixel) / ScreenSize.y;
    else if(_x < 7 * pixel) return (2.0 * pixel) / ScreenSize.y;
    else if(_x < 11 * pixel) return (3.0 * pixel) / ScreenSize.y;
    else if(_x < 13 * pixel) return (2.0 * pixel) / ScreenSize.y;
    else if(_x < 15 * pixel) return (1.0 * pixel) / ScreenSize.y;
    else return (0.0 * pixel) / ScreenSize.y;
}
float block_1(float x, float size){
    float pixel = ScreenSize.x / size;
    float _x = mod(x * ScreenSize.x, pixel * 17);
    if(_x < 4 * pixel) return (0.0 * pixel) / ScreenSize.y;
    else if(_x < 4 * pixel) return (0.0 * pixel) / ScreenSize.y;
    else if(_x < 5 * pixel) return (1.0 * pixel) / ScreenSize.y;
    else if(_x < 10 * pixel) return (2.0 * pixel) / ScreenSize.y;
    else if(_x < 12 * pixel) return (3.0 * pixel) / ScreenSize.y;
    else if(_x < 15 * pixel) return (2.0 * pixel) / ScreenSize.y;
    else return (1.0 * pixel) / ScreenSize.y;
}
float block_2(float x, float size){
    float pixel = ScreenSize.x / size;
    float _x = mod(x * ScreenSize.x, pixel * 23);
    if(_x < 5 * pixel) return (0.0 * pixel) / ScreenSize.y;
    else if(_x < 7 * pixel) return (1.0 * pixel) / ScreenSize.y;
    else if(_x < 10 * pixel) return (2.0 * pixel) / ScreenSize.y;
    else if(_x < 16 * pixel) return (3.0 * pixel) / ScreenSize.y;
    else if(_x < 19 * pixel) return (2.0 * pixel) / ScreenSize.y;
    else if(_x < 21 * pixel) return (1.0 * pixel) / ScreenSize.y;
    else if(_x < 22 * pixel) return (2.0 * pixel) / ScreenSize.y;
    else return (1.0 * pixel) / ScreenSize.y;
}
void main() {
    float bright = -mod(GameTime * 10, 1.0);
    float vert = (gl_FragCoord.y) / ScreenSize.y;
    vec3 color;
    float y0 = 0.25 + 0.02 * sin(GameTime * 500) + block_0((gl_FragCoord.x) / ScreenSize.x + GameTime * 10.0, 42.0);
    float y1 = 0.4 + 0.01 * sin(GameTime * 500) + block_1((gl_FragCoord.x) / ScreenSize.x + GameTime * 18.0, 74.0);
    float y2 = 0.5 + 0.004 * sin(GameTime * 500) + block_2((gl_FragCoord.x) / ScreenSize.x + GameTime * 24.0, 80.0);
    if(vert < y0){
        color = vec3(0.0, 61.0 / 255.0, 114.0 / 255.0);
    }
    else if(vert < y1){
        color = vec3(0.0, 147.0 / 255.0, 185.0 / 255.0);
    }
    else if(vert < y2){
        color = vec3(0.0, 191.0 / 255.0, 229.0 / 255.0);
    }
    else{
        color = vec3(101.0 / 255.0, 203.0 / 255.0, 226.0 / 255.0);
    }
    color = rgb2hsv(color);
    color.x = mod(GameTime * 1000.0, 360.0) / 360;
    color.z *= 0.2;
    color = hsv2rgb(color);
    fragColor = vec4(color, 1.0);
}
